local UrzUI = CreateFrame("Frame");
local UrzConfig = CreateFrame("Frame");
local UrzChat = CreateFrame("Frame");
local UrzNameplates = CreateFrame("Frame");
local UrzStats = CreateFrame("Frame", nil, MainMenuBar);
local UrzRepair = CreateFrame("Frame");

local function SetUI()
   local function Remove(name)
      if ( name ) then
         if ( name:GetObjectType() == "Texture" ) then
            name:SetTexture(nil);
         elseif ( name:GetObjectType() ~= "FontString" ) then
            name:HookScript("OnShow", function(self)
                  self:Hide();
            end);
         end
         name:Hide();
      end
   end
   for _, name in pairs({MainMenuBarPageNumber, ActionBarUpButton, ActionBarDownButton, MainMenuBarLeftEndCap, MainMenuBarRightEndCap, MainMenuXPBarTextureLeftCap, MainMenuXPBarTextureMid, MainMenuXPBarTextureRightCap, StanceBarLeft, StanceBarMiddle, StanceBarRight, SlidingActionBarTexture0, SlidingActionBarTexture1, PossessBackground1, PossessBackground2, OverrideActionBarEndCapL, OverrideActionBarEndCapR, MainMenuXPBarDiv1, MainMenuXPBarDiv2, MainMenuXPBarDiv3, MainMenuXPBarDiv4, MainMenuXPBarDiv5, MainMenuXPBarDiv6, MainMenuXPBarDiv7, MainMenuXPBarDiv8, MainMenuXPBarDiv9, MainMenuXPBarDiv10, MainMenuXPBarDiv11, MainMenuXPBarDiv12, MainMenuXPBarDiv13, MainMenuXPBarDiv14, MainMenuXPBarDiv15, MainMenuXPBarDiv16, MainMenuXPBarDiv17, MainMenuXPBarDiv18, MainMenuXPBarDiv19, MainMenuBarTexture0, MainMenuBarTexture1, MainMenuBarTexture2, MainMenuBarTexture3, ReputationXPBarTexture0, ReputationXPBarTexture1, ReputationXPBarTexture2, ReputationXPBarTexture3, ReputationWatchBarTexture0, ReputationWatchBarTexture1, ReputationWatchBarTexture2, ReputationWatchBarTexture3, MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, MinimapZoomIn, MinimapZoomOut, MiniMapTracking, CombatLogQuickButtonFrame_Custom}) do
      Remove(name);
   end
   for _, name in pairs({StanceBarFrame, PossessBarFrame, PetActionBarFrame, MultiBarLeft, MultiBarRight, MultiBarBottomLeft, MultiBarBottomRight, MainMenuBar, MainMenuBarMaxLevelBar, UIErrorsFrame}) do
      name:SetFrameStrata("MEDIUM");
      name:EnableMouse(false);
   end
   for _, text in pairs({"ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "StanceButton", "PossessButton", "PetActionButton"}) do
      for i = 1, 12 do
         local name = _G[text..i];
         if ( name ) then
            name:GetNormalTexture():SetPoint("TOPLEFT", name, "TOPLEFT", -12, 12);
            name:GetNormalTexture():SetPoint("BOTTOMRIGHT", name, "BOTTOMRIGHT", 13, -13);
            name:SetSize(36, 36);
            name:SetScale(1);
         end
         Remove(_G[text..i.."FloatingBG"]);
         Remove(_G[text..i.."Name"]);
      end
   end
   MainMenuBarVehicleLeaveButton:SetSize(36, 36);
   for _, name in pairs({MainMenuBarVehicleLeaveButton, StanceBarFrame, PossessBarFrame, PetActionBarFrame, OverrideActionBar,  PetBattleFrame}) do
      name:SetScale(0.7);
   end
   MainMenuBar:SetWidth(512);
   MultiBarBottomLeftButton1:ClearAllPoints();
   MultiBarBottomLeftButton1:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6);
   MultiBarBottomRightButton1:ClearAllPoints();
   MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, 6);
   StanceButton1:ClearAllPoints();
   StanceButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   PossessButton1:ClearAllPoints();
   PossessButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
   PetActionButton10:ClearAllPoints();
   PetActionButton10:SetPoint("BOTTOMRIGHT", MultiBarBottomRightButton12, "TOPRIGHT", 0, 6);
   for i = 2, 10 do
      _G["StanceButton"..i]:ClearAllPoints();
      _G["StanceButton"..i]:SetPoint("LEFT", _G["StanceButton"..i-1], "RIGHT", 6, 0);
      _G["PetActionButton"..11-i]:ClearAllPoints();
      _G["PetActionButton"..11-i]:SetPoint("RIGHT", _G["PetActionButton"..12-i], "LEFT", -6, 0);
   end
   PossessButton2:ClearAllPoints();
   PossessButton2:SetPoint("LEFT",  PossessButton1, "RIGHT", 6, 0);
   local function setup()
      MainMenuBarVehicleLeaveButton:ClearAllPoints();
      if ( IsPossessBarVisible() ) then
         MainMenuBarVehicleLeaveButton:SetPoint("LEFT", PossessButton2, "RIGHT", 30, 0);
      elseif ( GetNumShapeshiftForms() > 0 ) then
         MainMenuBarVehicleLeaveButton:SetPoint("LEFT", _G["StanceButton"..GetNumShapeshiftForms()], "RIGHT", 30, 0);
      else
         MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
      end
   end
   if ( MainMenuBarVehicleLeaveButton:IsShown() ) then
      setup();
   end
   hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", setup);
   local function setup()
      CharacterMicroButton:ClearAllPoints();
      CharacterMicroButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -275, 1);
      PVPMicroButton:ClearAllPoints();
      PVPMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -3, 0);
   end
   if ( MainMenuBar:IsShown() ) then
      setup();
   end
   MainMenuBar:HookScript("OnShow", setup);
   local function setup()
      MainMenuExpBar:SetSize(300, 13);
      ReputationWatchStatusBar:SetSize(300, 13);
      ReputationWatchBar:SetSize(300, 13);
      ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, "CENTER", 0, 1);
      ReputationWatchBarOverlayFrame:SetFrameStrata("MEDIUM");
      local y = 40;
      MainMenuExpBar:ClearAllPoints();
      MainMenuExpBar:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
      if ( MainMenuExpBar:IsShown() ) then
         y = y+16;
      end
      ReputationWatchBar:ClearAllPoints();
      ReputationWatchBar:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
      if ( ReputationWatchBar:IsShown() ) then
         y = y+16;
      end
      MainMenuBarBackpackButton:ClearAllPoints();
      MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
   end
   setup();
   hooksecurefunc("ReputationWatchBar_Update", setup);
   CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 1;
   CHAT_FRAME_TAB_NORMAL_MOUSEOVER_ALPHA = 0.5;
   CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0.5;
   DEFAULT_CHATFRAME_ALPHA = 0;
   CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 1;
   for i = 1, NUM_CHAT_WINDOWS do
      for _, text in pairs({"TabLeft", "TabMiddle", "TabRight", "TabSelectedLeft", "TabSelectedMiddle", "TabSelectedRight", "TabHighlightLeft", "TabHighlightMiddle", "TabHighlightRight", "ButtonFrameMinimizeButton", "ButtonFrameDownButton", "ButtonFrameUpButton", "ButtonFrameBackground", "ButtonFrameTopLeftTexture", "ButtonFrameBottomLeftTexture", "ButtonFrameTopRightTexture", "ButtonFrameBottomRightTexture", "ButtonFrameLeftTexture", "ButtonFrameRightTexture", "ButtonFrameBottomTexture", "ButtonFrameTopTexture"}) do
         Remove(_G["ChatFrame"..i..text]);
      end
      _G["ChatFrame"..i]:SetClampRectInsets(0, 0, 0, -30);
      FCFTab_UpdateAlpha(_G["ChatFrame"..i]);
      if ( i ~= 1 ) then
         _G["ChatFrame"..i.."EditBox"]:SetAllPoints(ChatFrame1EditBox);
      end
   end
   FCFManager_RegisterDedicatedFrame(ChatFrame2, "PET_BATTLE_COMBAT_LOG");
   CombatLogQuickButtonFrame_Custom:SetHeight(0);
   for name in pairs(ChatTypeGroup) do
      SetChatColorNameByClass(name, true);
   end
   for i = 1, MAX_WOW_CHAT_CHANNELS do
      local name = "CHANNEL"..i;
      if ( name ) then
         SetChatColorNameByClass(name, true);
      end
   end
   CompactUnitFrameProfilesGeneralOptionsFrameHeightSlider:SetMinMaxValues(20, 40);
   hooksecurefunc("GameTooltip_SetDefaultAnchor", function (tooltip, parent)
         tooltip:SetOwner(parent, "ANCHOR_NONE");
         tooltip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 140);
   end);
   hooksecurefunc("TextStatusBar_UpdateTextString", function(textStatusBar)
         if ( textStatusBar == TargetFrameHealthBar ) then
            local health = UnitHealth("target") or 0;
            if ( health > 0 ) then
               TargetFrameTextureFrameHealthBarText:SetFormattedText("%s   %i%%", AbbreviateLargeNumbers(health), ceil(health/UnitHealthMax("target")*100));
            end
         end
   end);
   UrzRepair:RegisterEvent("MERCHANT_SHOW");
   UrzRepair:SetScript("OnEvent", function(self, event, ...)
         for bag = 0, 4 do
            for slot = 0, GetContainerNumSlots(bag) do
               local link = GetContainerItemLink(bag, slot);
               if ( link and (select(3, GetItemInfo(link)) == 0) ) then
                  UseContainerItem(bag, slot);
               end
            end
         end
         RepairAllItems(1);
   end);
   AbbreviateLargeNumbers = function(number)
      number = tonumber(number);
      if ( number ) then
         if ( number < 1000 ) then
            return format("%.0f", number);
         elseif ( number < 100000 ) then
            return format("%.1f k", number/1000);
         elseif ( number < 1000000 ) then
            return format("%.0f k", number/1000);
         elseif ( number < 100000000 ) then
            return format("%.1f M", number/1000000);
         else
            return format("%.0f M", number/1000000);
         end
      end
   end
   Minimap:EnableMouseWheel(true);
   Minimap:SetScript("OnMouseWheel", function(self, delta)
         local zoom = Minimap:GetZoom();
         if ( delta > 0 and zoom < 5 ) then
            Minimap:SetZoom(zoom+1);
         elseif ( delta < 0 and zoom > 0 ) then
            Minimap:SetZoom(zoom-1);
         end
   end);
   Minimap:SetScript("OnMouseUp", function(self, button)
         if ( button == "LeftButton" ) then
            _G.Minimap_OnClick(self);
         elseif ( button == "RightButton" ) then
            _G.ToggleDropDownMenu(1, nil, _G.MiniMapTrackingDropDown, self);
         end
   end);
   ChatFrameMenuButton:SetScript("OnClick", function(self, button)
         if ( not ChatMenu:IsShown() ) then
            PlaySound("igChatEmoteButton");
            ChatFrame_OpenMenu();
         else
            ChatMenu:Hide();
         end
   end);
   for _, text in pairs({"Crit", "Haste", "Mastery", "Power", "Health", "Absorbs"}) do
      local label = "UrzStats"..text.."Label";
      local stats = "UrzStats"..text;
      label = UrzStats:CreateFontString(label, "ARTWORK", "GameFontHighlightSmall");
      stats = UrzStats:CreateFontString(stats, "ARTWORK", "TextStatusBarText");
      label:ClearAllPoints();
      label:SetPoint("BOTTOMLEFT", stats, "TOPLEFT", 0, 2);
      label:SetText(text);
      stats:ClearAllPoints();
   end
   UrzStatsPower:SetFont(STANDARD_TEXT_FONT, 18, "THINOUTLINE");
   UrzStatsHealth:SetFont(STANDARD_TEXT_FONT, 13, "THINOUTLINE");
   UrzStatsAbsorbs:SetFont(STANDARD_TEXT_FONT, 13, "THINOUTLINE");
   local function setup()
      UrzStatsCrit:ClearAllPoints();
      if ( StanceBarFrame:IsShown() or PossessBarFrame:IsShown() or MainMenuBarVehicleLeaveButton:IsShown() ) then
         UrzStatsCrit:SetPoint("BOTTOMLEFT", StanceButton1, "TOPLEFT", 0, 6);
      else
         UrzStatsCrit:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
      end
   end
   setup();
   for _, text in pairs({"StanceBarFrame", "PossessBarFrame", "MainMenuBarVehicleLeaveButton"}) do
      local name = _G[text];
      if ( name ) then
         for _, event in pairs({"OnShow", "OnHide"}) do
            name:HookScript(event, setup);
         end
      end
   end
   UrzStatsHaste:SetPoint("BOTTOMLEFT", UrzStatsCrit, "BOTTOMRIGHT", 6, 0);
   UrzStatsMastery:SetPoint("BOTTOMLEFT", UrzStatsHaste, "BOTTOMRIGHT", 6, 0);
   UrzStatsPower:SetPoint("BOTTOMLEFT", UrzStatsCrit, "TOPLEFT", 0, 15);
   UrzStatsHealth:SetPoint("BOTTOMLEFT", UrzStatsPower, "TOPLEFT", 0, 15);
   UrzStatsAbsorbs:SetPoint("BOTTOMLEFT", UrzStatsHealth, "BOTTOMRIGHT", 6, 0);
end

local function OptionAutoSize()
   if ( UrzOption.AutoSize ) then
      local function setup()
         ChatFrame1:ClearAllPoints();
         ChatFrame1:SetPoint("BOTTOMLEFT", UIParent, 34, 34);
         ChatFrame1:SetSize(GetScreenWidth()/2-292, 115);
         for i = 1, NUM_CHAT_WINDOWS do
            FCF_UpdateButtonSide(_G["ChatFrame"..i]);
         end
         FCF_SetLocked(ChatFrame1, true);
         ChatFrame1:SetUserPlaced(true);
      end
      setup();
      UrzChat:RegisterEvent("PLAYER_ENTERING_WORLD");
      UrzChat:RegisterEvent("DISPLAY_SIZE_CHANGED");
      UrzChat:RegisterEvent("UI_SCALE_CHANGED");
      UrzChat:SetScript("OnEvent", setup);
      UrzChat:Show();
   else
      UrzChat:UnregisterAllEvents();
      UrzChat:SetScript("OnEvent", nil);
      UrzChat:Hide();
   end
end

local function OptionStackedLog()
   if ( UrzOption.StackedLog ) then
      FCF_UnDockFrame(ChatFrame2);
      FCF_SetTabPosition(ChatFrame2, 0);
      FCF_FadeOutChatFrame(ChatFrame2);
      FCF_SetChatWindowFontSize(nil, ChatFrame2, 12);
      FloatingChatFrame_Update(2);
      ChatFrame2:ClearAllPoints();
      ChatFrame2:SetPoint("BOTTOMLEFT", ChatFrame1, "TOPLEFT", 0, 44);
      ChatFrame2:SetSize(ChatFrame1:GetWidth(), 65);
      FCF_UpdateButtonSide(ChatFrame2);
      FCF_SetLocked(ChatFrame2, true);
   else
      FCF_DockFrame(ChatFrame2, 2, false);
      FCF_SetChatWindowFontSize(nil, ChatFrame2, select(2, ChatFrame1:GetFont()));
   end
end

local function OptionThickFont()
   for i = 1, NUM_CHAT_WINDOWS do
      local size = select(2, _G["ChatFrame"..i]:GetFont());
      local tabsize = select(2, _G["ChatFrame"..i.."TabText"]:GetFont());
      if ( UrzOption.ThickFont ) then
         _G["ChatFrame"..i]:SetFont(_G["ChatFrame"..i]:GetFont(), size, "OUTLINE");
         _G["ChatFrame"..i.."TabText"]:SetFont(_G["ChatFrame"..i.."TabText"]:GetFont(), tabsize, "OUTLINE");
      else
         _G["ChatFrame"..i]:SetFont(_G["ChatFrame"..i]:GetFont(), size);
         _G["ChatFrame"..i.."TabText"]:SetFont(_G["ChatFrame"..i.."TabText"]:GetFont(), tabsize);
      end
   end
   FCF_DockUpdate();
end

local function OptionHideError()
   if ( UrzOption.HideError ) then
      UIErrorsFrame:Hide();
   else
      UIErrorsFrame:Show();
   end
end

local function OptionShowNameplates()
   if ( UrzOption.ShowNameplates ) then
      UrzNameplates:SetScript("OnUpdate", function(self, elapsed)
            for i = 1, WorldFrame:GetNumChildren() do
               local frame = select(i, WorldFrame:GetChildren());
               if ( frame:GetName() and frame:GetName():match("NamePlate") ) then
                  local plate, name = frame:GetChildren();
                  local threat, bg, _, lvl = plate:GetRegions();
                  local font = name:GetRegions();
                  if ( bg:GetAlpha() > 0 ) then
                     bg:SetAlpha(0);
                     font:SetFont("Fonts\\ARIALN.TTF", 12, nil);
                     font:SetShadowOffset(1, -1);
                     lvl:SetFont("Fonts\\ARIALN.TTF", 12, nil);
                     lvl:SetShadowOffset(1, -1);
                  end
                  if ( threat:IsShown() ) then
                     font:SetTextColor(1, 0.3, 0, 1);
                  else
                     font:SetTextColor(1, 1, 1, 1);
                  end
                  if ( UnitExists("target") and frame:GetAlpha() == 1 ) then
                     threat:SetVertexColor(1, 1, 1, 1);
                     threat:Show();
                  else
                     threat:Hide();
                  end
                  frame:SetAlpha(1);
               end
            end
      end);
      UrzNameplates:Show();
   else
      UrzNameplates:SetScript("OnUpdate", nil);
      UrzNameplates:Hide();
   end
end

function OptionStatsDisplay()
   if ( UrzOption.StatsDisplay ) then
      local wait = 0;
      UrzStats:SetScript("OnUpdate", function(self, elapsed)
            wait = wait+elapsed;
            if ( wait > 0.2 ) then
               wait = 0;
               local crit, haste, power;
               local _, class = UnitClass("player");
               local spec = GetSpecialization();
               if ( class == "HUNTER" ) then
                  UrzStatsPowerLabel:SetText("Attack Power");
                  crit = GetRangedCritChance();
                  haste = GetRangedHaste();
                  if ( GetOverrideAPBySpellPower() ~= nil ) then
                     power = GetSpellBonusDamage(2);
                     for i = 3, 7 do
                        power = min(power, GetSpellBonusDamage(i));
                     end
                     power = min(power, GetSpellBonusHealing())*GetOverrideAPBySpellPower();
                  else
                     local base, buff, debuff = UnitRangedAttackPower("player");
                     power = max(base+buff+debuff or 0, 0);
                  end
               elseif (( class == "WARLOCK" )
                  or ( class == "MAGE" )
                  or (( class == "PRIEST" ) and ( spec == 3 ))
                  or (( class == "DRUID" ) and ( spec == 1))
                  or (( class == "SHAMAN" ) and ( spec == 1 ))) then
                  UrzStatsPowerLabel:SetText("Spell Power");
                  crit = GetSpellCritChance(2);
                  power = GetSpellBonusDamage(2);
                  for i = 3, 7 do
                     power = min(power, GetSpellBonusDamage(i));
                     crit = min(crit, GetSpellCritChance(i));
                  end
                  haste = UnitSpellHaste("player");
               elseif ((( class == "PRIEST" ) and ( spec ~= 3 ))
                  or (( class == "DRUID" ) and ( spec == 4 ))
                  or (( class == "MONK" ) and ( spec == 2 ))
                  or (( class == "PALADIN" ) and ( spec == 1 ))
                  or (( class == "SHAMAN" ) and ( spec == 3 ))) then
                  UrzStatsPowerLabel:SetText("Healing Power");
                  crit = GetSpellCritChance(2);
                  for i = 3, 7 do
                     crit = min(crit, GetSpellCritChance(i));
                  end
                  haste = UnitSpellHaste("player");
                  power = GetSpellBonusHealing();
               else
                  UrzStatsPowerLabel:SetText("Attack Power");
                  crit = GetCritChance();
                  haste = GetMeleeHaste();
                  if ( GetOverrideAPBySpellPower() ~= nil ) then
                     power = GetSpellBonusDamage(2);
                     for i = 3, 7 do
                        power = min(power, GetSpellBonusDamage(i));
                     end
                     power = min(power, GetSpellBonusHealing())*GetOverrideAPBySpellPower();
                  else
                     local base, buff, debuff = UnitAttackPower("player");
                     power = max(base+buff+debuff or 0, 0);
                  end
               end
               UrzStatsCrit:SetFormattedText("%.1F%%", crit);
               UrzStatsHaste:SetFormattedText("%.1F%%", haste);
               if ( UnitLevel("player") < 80 ) then
                  UrzStatsMasteryLabel:Hide();
                  UrzStatsMastery:Hide();
               else
                  UrzStatsMasteryLabel:Show();
                  UrzStatsMastery:Show();
                  UrzStatsMastery:SetFormattedText("%.1F%%", GetMasteryEffect());
               end
               UrzStatsPower:SetText(AbbreviateLargeNumbers(power));
               UrzStatsHealth:SetText(AbbreviateLargeNumbers(UnitHealth("player")));
               if ( UnitGetTotalAbsorbs("player") < 1 ) then
                  UrzStatsAbsorbsLabel:Hide();
                  UrzStatsAbsorbs:Hide();
               else
                  UrzStatsAbsorbsLabel:Show();
                  UrzStatsAbsorbs:Show();
                  UrzStatsAbsorbs:SetText(AbbreviateLargeNumbers(UnitGetTotalAbsorbs("player")));
               end
            end
      end);
      UrzStats:Show();
   else
      UrzStats:SetScript("OnUpdate", nil);
      UrzStats:Hide();
   end
end

local function SetConfig()
   UrzConfig.name = "UrzUI";
   InterfaceOptions_AddCategory(UrzConfig);
   SlashCmdList["UrzSlash"] = function()
      InterfaceOptionsFrame:Show();
      InterfaceOptionsFrame_OpenToCategory("UrzUI");
   end;
   SLASH_UrzSlash1 = "/urz";
   SLASH_UrzSlash2 = "/urzui";
   local text1 = UrzConfig:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
   local text2 = UrzConfig:CreateFontString(nil, "ARTWORK", "QuestFont_Large");
   local box1 = CreateFrame("CheckButton", "UrzConfigBox1", UrzConfig, "UICheckButtonTemplate");
   local box2 = CreateFrame("CheckButton", "UrzConfigBox2", UrzConfig, "UICheckButtonTemplate");
   local box3 = CreateFrame("CheckButton", "UrzConfigBox3", UrzConfig, "UICheckButtonTemplate");
   local box4 = CreateFrame("CheckButton", "UrzConfigBox4", UrzConfig, "UICheckButtonTemplate");
   local box5 = CreateFrame("CheckButton", "UrzConfigBox5", UrzConfig, "UICheckButtonTemplate");
   local box6 = CreateFrame("CheckButton", "UrzConfigBox6", UrzConfig, "UICheckButtonTemplate");
   if ( not UrzOption ) then
      UrzOption = {
         ThickFont = false,
         StackedLog = false,
         AutoSize =  true,
         HideError = true,
         ShowNameplates = true,
         StatsDisplay = false,
      };
   end
   local function setup()
      box1:SetChecked(UrzOption.ThickFont);
      box2:SetChecked(UrzOption.StackedLog);
      box3:SetChecked(UrzOption.AutoSize);
      box4:SetChecked(UrzOption.HideError);
      box5:SetChecked(UrzOption.ShowNameplates);
      box6:SetChecked(UrzOption.StatsDisplay);
   end
   setup();
   UrzConfig:SetScript("OnShow", setup);
   text1:SetPoint("TOPLEFT", 16, -16);
   text1:SetText("UrzUI Configuration");
   text2:SetJustifyH("RIGHT");
   text2:SetPoint("BOTTOMRIGHT", -16, 16);
   text2:SetText("To my beloved Madelene :) \n\n– Fredrik   ");
   box1:ClearAllPoints();
   box1:SetPoint("TOPLEFT", 16, -40);
   _G[box1:GetName().."Text"]:SetText("Sets a thicker outlined chat font.");
   box1:SetScript("OnClick", function(self, button, down)
         UrzOption.ThickFont = box1:GetChecked();
         OptionThickFont();
   end);
   OptionThickFont();
   box2:ClearAllPoints();
   box2:SetPoint("TOPLEFT", 16, -65);
   _G[box2:GetName().."Text"]:SetText("Stack the combat log above the chat window.");
   box2:SetScript("OnClick", function(self, button, down)
         UrzOption.StackedLog = box2:GetChecked();
         OptionStackedLog();
   end);
   OptionStackedLog();
   box3:ClearAllPoints();
   box3:SetPoint("TOPLEFT", 16, -90);
   _G[box3:GetName().."Text"]:SetText("Automatically set the size and position of the main chat window.");
   box3:SetScript("OnClick", function(self, button, down)
         UrzOption.AutoSize = box3:GetChecked();
         OptionAutoSize();
   end);
   OptionAutoSize();
   box4:ClearAllPoints();
   box4:SetPoint("TOPLEFT", 16, -115);
   _G[box4:GetName().."Text"]:SetText("Hide error messages.");
   box4:SetScript("OnClick", function(self, button, down)
         UrzOption.HideError = box4:GetChecked();
         OptionHideError();
   end);
   OptionHideError();
   box5:ClearAllPoints();
   box5:SetPoint("TOPLEFT", 16, -140);
   _G[box5:GetName().."Text"]:SetText("Enable UrzUI's nameplates. (Disable this if you want to use another nameplate addon.)");
   box5:SetScript("OnClick", function(self, button, down)
         UrzOption.ShowNameplates = box5:GetChecked();
         OptionShowNameplates();
   end);
   OptionShowNameplates();
   box6:ClearAllPoints();
   box6:SetPoint("TOPLEFT", 16, -165);
   _G[box6:GetName().."Text"]:SetText("Enable UrzUI's stats display.");
   box6:SetScript("OnClick", function(self, button, down)
         UrzOption.StatsDisplay = box6:GetChecked();
         OptionStatsDisplay();
   end);
   OptionStatsDisplay();
end

UrzUI:RegisterEvent("PLAYER_ENTERING_WORLD");
UrzUI:RegisterEvent("PLAYER_REGEN_ENABLED");
UrzUI:SetScript("OnEvent", function(self, event, ...)
      if ( not UnitAffectingCombat("player") ) then
         SetUI();
         SetConfig();
         UrzUI:UnregisterAllEvents();
         UrzUI:SetScript("OnEvent", nil);
         UrzUI:Hide();
      end
end);
